//******************************************************************
//* LOCKHEED MARTIN SPACE DAY 2009
//* LAST UPDATED 04/29/2009
//* CHANGES/ADDITIONS
//******************************************************************b
#include <pic18.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <htc.h>
#include "ecan.h"
#include "ecan.c"

// Settings for PIC18F6680
__CONFIG(1,HS);
__CONFIG(2,BORDIS & PWRTDIS & WDTDIS);
__CONFIG(3,MCLREN);
__CONFIG(4,DEBUGEN & LVPDIS & STVREN);
__CONFIG(5,UNPROTECT);
__CONFIG(6,WRTEN);
__IDLOC(0429);
//******************************************************************
//*	FUNCTION PROTOTYPES
//******************************************************************
void send_can_msg8(char dest_addr, char cmd, char a,char b ,char c, char d, char e, char f);
void send_can_msg7(char dest_addr, char cmd, char a,char b ,char c, char d, char e);
void send_can_msg6(char dest_addr, char cmd, char a,char b ,char c, char d);
void send_can_msg5(char dest_addr, char cmd, char a,char b ,char c);
void send_can_msg4(char dest_addr, char cmd, char a,char b );
void send_can_msg3(char dest_addr, char cmd, char a);
void send_can_msg2(char dest_addr, char cmd);
void motor(char mtr, char dir);
void reset_tmr(char timer);
void interrupt TIMERS(void);
void init(void);
//******************************************************************
//*	ECAN DEFINITIONS
//******************************************************************
unsigned long id;
char data[8];
char dataLen;
ECAN_RX_MSG_FLAGS canflags;

char my_addr,dest_addr;
unsigned int my_id;

#define id_motor	0x1A0
#define id_team1	0x1A1
#define id_team2	0x1A2
#define id_team3	0x1A3

#define	addr_motor	0xA0
#define addr_team1	0xA1
#define addr_team2	0xA2
#define addr_team3	0xA3
//******************************************************************
//* ECAN COMMANDS
//******************************************************************
#define	cblink1		0x01
#define	cblink2		0x02
#define	cblinkleds	0x03
#define cblinkoff	0x04
#define cmtr1		0x05
#define cmtr2		0x06
#define cmtr3		0x07
//******************************************************************
//*	GLOBALS
//******************************************************************
unsigned int temp16,scratch16;
char temp8,scratch8;
char hundreds, tens, ones;
unsigned int tmsecs1,tmsecs2,tmsecs3;
unsigned int imsecs1,imsecs2,imsecs3;
char tsecs1,tsecs2,tsecs3;
char isecs1,isecs2,isecs3;
char tmins2,tmins3;
char imins2,imins3;
//******************************************************************
//*	Flags
//******************************************************************
typedef struct
{
	char drvr1:1;
	char drvr2:1;
	char drvr3:1;
	char drvr4:1;
	char drvr5:1;
	char drvr6:1;
	char fwd1:1;
	char rev1:1;
	char halt1:1;
	char fwd2:1;
	char rev2:1;
	char halt2:1;
	char fwd3:1;
	char rev3:1;
	char halt3:1;
} SSTAT;

SSTAT stat;
//******************************************************************
//    MACROS AND PORT/PIN DEFINITIONS
//******************************************************************
#define bitset(var, bitno) ((var) |= 1 << (bitno))
#define bitclr(var, bitno) ((var) &= ~(1 << (bitno)))
#define make8(var,offset)	((unsigned int)var >> (offset * 8)) & 0x00FF
#define	make16(varhigh,varlow)	(((unsigned int)varhigh & 0xFF)* 0x100) + ((unsigned int)varlow & 0x00FF)
#define make32(var1,var2,var3,var4) \
		((unsigned long)var1<<24)+((unsigned long)var2<<16)+ \
		((unsigned long)var3<<8)+((unsigned long)var4)		
#define make32i(var1,var2) ((unsigned long)var1<<16)+((unsigned long)var2)
//******************************************************************
//*	I/0 DEFINITIONS
//******************************************************************
#define	mtr1	1
#define mtr2	2
#define mtr3	3
#define	cw		4
#define	ccw		5
#define stop	6

#define	drvr_1			LATB1	
#define	drvr_1_ON		drvr_1 = 1;	\
						stat.drvr1 = 1;
#define	drvr_1_OFF		drvr_1 = 0;	\
						stat.drvr1 = 0;
	
#define drvr_2			LATB2	
#define drvr_2_ON		drvr_2 = 1;	\
						stat.drvr2 = 1;
#define drvr_2_OFF		drvr_2 = 0;	\
						stat.drvr2 = 0;

#define drvr_3			LATB3	
#define drvr_3_ON		drvr_3 = 1;	\
						stat.drvr3 = 1;
#define drvr_3_OFF		drvr_3 = 0;	\
						stat.drvr3 = 0;

#define	drvr_4			LATB4
#define	drvr_4_ON		drvr_4 = 1;	\
						stat.drvr4 = 1;
#define drvr_4_OFF		drvr_4 = 0;	\
						stat.drvr4 = 0;
						
#define	drvr_5			LATB5
#define	drvr_5_ON		drvr_5 = 1;	\
						stat.drvr5 = 1;
#define drvr_5_OFF		drvr_5 = 0;	\
						stat.drvr5 = 0;

#define	drvr_6			LATC2
#define	drvr_6_ON		drvr_6 = 1;	\
						stat.drvr6 = 1;
#define	drvr_6_OFF		drvr_6 = 0;	\
						stat.drvr6 = 0;

#define	act_led			LATC0
//******************************************************************
//*	INTERRUPT DEFINITIONS
//******************************************************************
#define		disable_RXint	  	RCIE = 0
#define		enable_RXint	  	RCIE = 1
#define		disable_TMR2int  	TMR2IE = 0
#define		enable_TMR2int	 	TMR2IE = 1
#define		disable_TMR3int  	TMR3IE = 0
#define		enable_TMR3int	 	TMR3IE = 1
#define		disable_TMR1int  	TMR1IE = 0
#define		enable_TMR1int	 	TMR1IE = 1
#define		disable_TMR0int  	TMR0IE = 0
#define		enable_TMR0int	 	TMR0IE = 1

#define		enable_GLOBALint  	IPEN = 0;				\
							  	GIE = 1;				\
							  	PEIE = 1;
#define		disable_GLOBALint 	IPEN = 0;				\
							  	GIE = 0;				\
							  	PEIE = 0;
#define		TIMER0ON			TMR0ON = 1
#define		TIMER0OFF			TMR0ON = 0
#define		TIMER1ON			TMR1ON = 1
#define		TIMER1OFF			TMR1ON = 0
#define		TIMER2ON		  	TMR2ON = 1
#define		TIMER2OFF		  	TMR2ON = 0
#define		TIMER3ON		  	TMR3ON = 1
#define		TIMER3OFF		  	TMR3ON = 0

#define mdelay1(msecdelay)		TIMER1OFF;					\
								TMR1IF = 0;					\
								imsecs1 = 0;				\
								tmsecs1 = 0;				\
								TIMER1ON;					\
								while(tmsecs1 < msecdelay);
								
#define	sdelay1(secdelay)		TIMER1OFF;					\
								TMR1IF = 0;					\
								imsecs1 = 0;				\
								tmsecs1 = 0;				\
								isecs1 = 0;					\
								tsecs1 = 0;					\
								TIMER1ON;					\
								while(tsecs1 < secdelay);
//****************************************************************************
//*	SEND CAN MESSAGES
//****************************************************************************
void send_can_msg8(char dest_addr, char cmd, char a,char b ,char c, char d, char e, char f)
{
	dataLen = 8;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	data[3] = b;
	data[4] = c;
	data[5] = d;
	data[6] = e;
	data[7] = f;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg7(char dest_addr, char cmd, char a,char b ,char c, char d, char e)
{
	dataLen = 7;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	data[3] = b;
	data[4] = c;
	data[5] = d;
	data[6] = e;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg6(char dest_addr, char cmd, char a,char b ,char c, char d)
{
	dataLen = 6;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	data[3] = b;
	data[4] = c;
	data[5] = d;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg5(char dest_addr, char cmd, char a,char b ,char c)
{
	dataLen = 5;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	data[3] = b;
	data[4] = c;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg4(char dest_addr, char cmd, char a,char b)
{
	dataLen = 4;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	data[3] = b;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg3(char dest_addr, char cmd, char a)
{
	dataLen = 3;
	data[0] = dest_addr;
	data[1] = cmd;
	data[2] = a;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
void send_can_msg2(char dest_addr, char cmd)
{
	dataLen = 2;
	data[0] = dest_addr;
	data[1] = cmd;
	while(!ECANSendMessage(id, data, dataLen, ECAN_TX_STD_FRAME));
	mdelay1(10);
}
//******************************************************************
//* RESET TIMERS ROUTINE
//******************************************************************
void reset_tmr(char timer)
{
	switch(timer)
	{
		case 1:
			TIMER1OFF;
			TMR1IF = 0;
			TMR1H = 0xEC;	
			TMR1L = 0x77;
			imsecs1 = 0;
			isecs1 = 0;
			tmsecs1 = 0;
			tsecs1 = 0;
		break;

		case 2:
			TIMER2OFF;
			TMR2IF = 0;
			imsecs2 = 0;
			imins2 = 0;
			isecs2 = 0;
			tmsecs2 = 0;
			tsecs2 = 0;
			tmins2 = 0;
		break;

		case 3:
			TIMER3OFF;
			TMR3IF = 0;
			TMR3H = 0xEC;	
			TMR3L = 0x77;
			imsecs3 = 0;
			isecs3 = 0;
			imins3 = 0;
			tmsecs3 = 0;
			tsecs3 = 0;
			tmins3 = 0;
		break;
	}
}
//******************************************************************
//*	INTERRUPT HANDLER ROUTINE
//******************************************************************
void interrupt TIMERS(void)
{
  unsigned char usart_data,tmphead,tmptail;
	if((TMR3IF && TMR3IE))
	{
		TMR3IF = 0;
		TMR3H = 0xEC;	
		TMR3L = 0x77;
		++tmsecs3;
		 if(++imsecs3 == 1000)
         {
          imsecs3 = 0;
          ++isecs3;
          ++tsecs3;
 		  act_led ^= 1;
        }
	    if(isecs3 == 60)
	     {
			isecs3 = 0;
			++imins3;
		 	++tmins3;
		 }
	}

	if((TMR1IF && TMR1IE))
	{
		TMR1IF = 0;
		TMR1H = 0xEC;	
		TMR1L = 0x77;

		++tmsecs1;
		if(++imsecs1 == 1000)
		{
			imsecs1 = 0;
			++isecs1;
			++tsecs1;
		}
	}

} 
//****************************************************************************
//*	INITIALIZE ROUTINE
//****************************************************************************
void init(void)
{
	char i;
	
	my_addr = addr_motor;
	my_id = id_motor;

   	TRISA = 0b11111111;		
   	TRISB = 0b11000000;		
   	TRISC = 0b10010010;
   	TRISD = 0b11111111;
   	TRISE = 0b11111111;
   	TRISF = 0b11111111;
   	TRISG = 0b11111110;
   	PSPMODE = 0;
	motor(1,stop);
	motor(2,stop);
	motor(3,stop);
//******************************************************************
//*	CONFIGURE EEPROM READ/WRITE
//******************************************************************
	EECON1 = 0b00000000;
//******************************************************************
//*	CONFIGURE A2D AND COMPARATORS
//******************************************************************
	ADCON0 = 0b00000000;	//turn OFF A2D
	ADCON1 = 0b00001111;	//all digital
//******************************************************************
//*	INITIALIZE CAN HARDWARE
//******************************************************************
   ECANInitialize();
//******************************************************************
//*	CONFIGURE AND START TIMER1
//* SET TO OVERFLOW EVERY 1mS
//******************************************************************
	TIMER1OFF;
	T1CON = 0b00000000;
	TMR1H = 0xEC;
	TMR1L = 0x77;
	TIMER1ON;
//******************************************************************
//*	CONFIGURE PWM FOR 600Hz
//******************************************************************
	TIMER2OFF;
//******************************************************************
//*	CONFIGURE AND START TIMER3
//* SET TO OVERFLOW EVERY 1mS
//******************************************************************
	imins3 = 0x00;
	isecs3 = 0x00;
  	imsecs3 = 0;
	T3CON = 0x00;		
	TMR3H = 0xEC;	
	TMR3L = 0x77;
	TIMER3ON;
//******************************************************************
//*	ACTIVATE INTERRUPTS
//******************************************************************
	enable_TMR1int;
	enable_TMR3int;
    enable_GLOBALint;
}
//******************************************************************
//*	MOTOR COMMANDS
//******************************************************************
void motor(char mtr, char dir)
{
	switch(dir)
	{
		case stop:
			switch(mtr)
			{
				case mtr1:
					drvr_6_OFF;
					drvr_5_OFF;
					stat.halt1 = 1;
					stat.fwd1 = 0;
					stat.rev1 = 0;
				break;
				case mtr2:
					drvr_4_OFF;
					drvr_3_OFF;
					stat.halt2 = 1;
					stat.fwd2 = 0;
					stat.rev2 = 0;
				break;
				case mtr3:
					drvr_2_OFF;
					drvr_1_OFF;
					stat.halt3 = 1;
					stat.fwd3= 0;
					stat.rev3= 0;
				break;
			}
		break;
		case cw:
			switch(mtr)
			{
				case mtr1:
					drvr_6_ON;
					drvr_5_OFF;
					stat.halt1 = 0;
					stat.fwd1 = 1;
					stat.rev1 = 0;
				break;
				case mtr2:
					drvr_4_ON;
					drvr_3_OFF;
					stat.halt2 = 0;
					stat.fwd2 = 1;
					stat.rev2 = 0;
				break;
				case mtr3:
					drvr_2_ON;
					drvr_1_OFF;
					stat.halt3 = 0;
					stat.fwd3 = 1;
					stat.rev3 = 0;
				break;
			}
		break;
		case ccw:
			switch(mtr)
			{
				case mtr1:
					drvr_6_OFF;
					drvr_5_ON;
					stat.halt1 = 0;
					stat.fwd1 = 0;
					stat.rev1 = 1;
				break;
				case mtr2:
					drvr_4_OFF;
					drvr_3_ON;
					stat.halt2 = 0;
					stat.fwd2 = 0;
					stat.rev2 = 1;
				break;
				case mtr3:
					drvr_2_OFF;
					drvr_1_ON;
					stat.halt3 = 0;
					stat.fwd3 = 0;
					stat.rev3 = 1;
				break;
			}
		break;
	}
}
void main(void)
{
//******************************************************************
//*	INITIALIZE
//******************************************************************
  	init();
//******************************************************************
//*	MAIN SERVICE LOOP
//******************************************************************
	do{

if(ECANReceiveMessage(&id, data, &dataLen, &canflags))
		{
		   	if (data[0] == my_addr)
		   	{
		   		switch(data[1])
			   		{
				   		case cmtr1:
					   		if(stat.halt1)
					   		{
					   			motor(1,cw);
					   		}
					   		else if(stat.fwd1)
					   		{	
						   		motor(1,stop);
						   		mdelay1(100);
						   		motor(1,ccw);
						   	}
						   	else if(stat.rev1)
						   	{
							   	motor(1,stop);
							}
				   		break;
				   		case cmtr2:
					   		if(stat.halt2)
					   		{
					   			motor(2,cw);
					   		}
					   		else if(stat.fwd2)
					   		{	
						   		motor(2,stop);
						   		mdelay1(100);
						   		motor(2,ccw);
						   	}
						   	else if(stat.rev2)
						   	{
							   	motor(2,stop);
							}
				   		break;
				   		case cmtr3:
					   		if(stat.halt3)
					   		{
					   			motor(3,cw);
					   		}
					   		else if(stat.fwd3)
					   		{	
						   		motor(3,stop);
						   		mdelay1(100);
						   		motor(3,ccw);
						   	}
						   	else if(stat.rev3)
						   	{
							   	motor(3,stop);
							}
				   		break;
			  		}
			  }
		}	 

  }while(1);

}
